#include <GUIConstants.au3>
#include <DirWalk.au3>

AutoItSetOption("MustDeclareVars",1)

Global $ed_Path,$ed_Pattern,$chk_Recurse,$chk_RE,$btn_Go,$btn_Stop,$btn_Copy,$ed_Out,$msg,$flags

GUICreate("DirWalkGUI",1024,768,197,115,$WS_SIZEBOX+$WS_SYSMENU)
GUICtrlCreateLabel("Path:",8,8,34,20)
$ed_Path=GUICtrlCreateInput("c:\",64,8,593,24)
GUICtrlCreateLabel("Pattern:",8,46,49,20)
$ed_Pattern=GUICtrlCreateInput("*",64,46,593,24)
$chk_Recurse=GUICtrlCreateCheckbox("Recurse",672,8,81,25)
$chk_RE=GUICtrlCreateCheckbox("Regular expression",672,48,153,25)
$btn_Go=GUICtrlCreateButton("Search!",872,8,81,24,0)
$btn_Stop=GUICtrlCreateButton("Stop!",872,46,81,24,0)
$btn_Copy=GUICtrlCreateButton("Copy to clipboard",8,96,153,25,0)
$ed_Out=GUICtrlCreateEdit("",8,128,1001,609)
GUICtrlSetState($btn_Stop,$GUI_DISABLE)
GUICtrlSetState($ed_Path,$GUI_FOCUS)
GUICtrlSetLimit($ed_Out,1024*1024)
GUISetState(@SW_SHOW)

Func FileCB($name,$isdir,$level)
	Local $msg
	$msg=GUIGetMsg()
	If $msg=$GUI_EVENT_CLOSE Then Exit
	If $msg=$btn_Stop Then Return $DW_BREAK_ALL
	If $isdir Then
		; do nothing
	Else
		GUICtrlSetData($ed_Out,$name&@CRLF,1)
	Endif
	Return $DW_CONTINUE
EndFunc

While 1
	$msg=GUIGetMsg()
	Select
		Case $msg=$GUI_EVENT_CLOSE
			Exit
		Case $msg=$btn_Go
			GUICtrlSetData($ed_Out,"")
			GUICtrlSetState($btn_Go,$GUI_DISABLE)
			GUICtrlSetState($btn_Copy,$GUI_DISABLE)
			GUICtrlSetState($btn_Stop,$GUI_ENABLE)
			$flags=0
			If GUICtrlRead($chk_Recurse)=$GUI_CHECKED Then $flags=1
			If GUICtrlRead($chk_RE)=$GUI_CHECKED Then $flags+=2
			_DirWalk(GUICtrlRead($ed_Path),GUICtrlRead($ed_Pattern),$flags,"FileCB")
			GUICtrlSetState($btn_Stop,$GUI_DISABLE)
			GUICtrlSetState($btn_Copy,$GUI_ENABLE)
			GUICtrlSetState($btn_Go,$GUI_ENABLE)
		Case $msg=$btn_Copy
			ClipPut(GUICtrlRead($ed_Out))
	EndSelect
WEnd
